


(*
 * o : (’a -> ’b) * (’c -> ’a) -> (’c -> ’b)
 * REQUIRES: true
 * ENSURES: (f o g) x =~ f (g x) 
 *)
infix o
fun (f:'a -> 'b) o (g:'c -> 'a) : 'c -> 'b = 
  fn x => f (g x)




(*
 * |> : 'a -> ('a -> 'b) -> 'b
 * REQUIRES: true
 * ENSURES: x |> f =~ f x
 *)
infix |>
fun (x:'a) |> (f:'a -> 'b) : 'b = 
  f x








fun inc x = x + 1
fun dbl x = 2 * x