

(*
 * filter : ('a -> bool) -> 'a list -> 'a list
 * REQUIRES: p is total
 * ENSURES: filter p lst ==> a list of only 
 *  those elements of lst satisfying p
 *)
fun filter (p:'a -> bool) (lst:'a list) : 'a list = 
  (case lst of 
      [] => [] 
    | x::xs => 
      if p x 
      then x::(filter p xs)
      else filter p xs
  )