

(*
 * map : ('a -> 'b) -> 'a list -> 'b list
 * REQUIRES: f is total
 * ENSURES: map f [x1,x2,...,xn] =~ [f x1, f x2,..., f xn]
 *)
fun map (f:'a -> 'b) (lst:'a list) : 'b list = 
  (case lst of 
      [] => [] 
    | x::xs => (f x)::(map f xs)
  )







